; ##############################################################################
; ##############################################################################
; ##############################################################################
; BIT-0: D4																		
; BIT-1: D5																		
; BIT-2: D6																		
; BIT-3: D7																		
; BIT-4: RS																		
; BIT-5: RW (0=WRITE)															
; BIT-6: ENABLE																	
; BIT-7: LIGHT (0=ON 1=OFF)														
EXT_DISPLAY_INITIALISIERUNG:
	; MASTER-START					
	ldi temp1,(ADRESSE_SLAVES_DISPLAY)	; ADRESSE laden		
	rcall TWI_MASTER_TRANSMITTER_START_TEMP1
	; ERROR							
	tst FEHLER_CODE
	brne EXT_DISPLAY_INITIALISIERUNG_ERROR
	; PORT auf HIGH					
	ldi temp1, (1<<DISP_LED)|(1<<DISP_E)|(1<<DISP_RW)|(1<<DISP_RS)|(1<<DISP_D7)|(1<<DISP_D6)|(1<<DISP_D5)|(1<<DISP_D4)	; 1
	rcall TWI_MASTER_TRANSMITTER_DATEN_TEMP1
	; ERROR							
	tst FEHLER_CODE
	breq EXT_DISPLAY_INITIALISIERUNG_RUN
	; ERROR							
EXT_DISPLAY_INITIALISIERUNG_ERROR:
	rcall TWI_STOP
	ret
;-------------------------------------------------------------------------------
EXT_DISPLAY_INITIALISIERUNG_RUN:
  	; x03 muss 3mal hintereinander gesendet werden zur Initialisierung			
	ldi temp1, (0<<DISP_LED)|(1<<DISP_E)|(0<<DISP_RW)|(0<<DISP_RS)|(0<<DISP_D7)|(0<<DISP_D6)|(1<<DISP_D5)|(1<<DISP_D4)	; E=1 RS=0
	rcall TWI_MASTER_TRANSMITTER_DATEN_TEMP1
	rcall EXT_DISPLAY_ENABLE_TEMP1
	rcall TWI_MASTER_TRANSMITTER_DATEN_TEMP1
	rcall EXT_DISPLAY_ENABLE_TEMP1
	rcall TWI_MASTER_TRANSMITTER_DATEN_TEMP1
	rcall EXT_DISPLAY_ENABLE_TEMP1

    ldi temp1, 0b00000010        ;4bit-Modus einstellen			
	rcall EXT_DISPLAY_COMMAND_TEMP1
	ldi temp1, 0b00101100        ; Function Set					
	rcall EXT_DISPLAY_COMMAND_TEMP1
    ldi temp1, 0b00001111        ; DISPLAY ein / CURSOR blinken	
	rcall EXT_DISPLAY_COMMAND_TEMP1
    ldi temp1, 0b00000110        ; Cursor Auto-Increment		
	rcall EXT_DISPLAY_COMMAND_TEMP1
	rcall EXT_DISPLAY_CLEAR

	rcall TWI_STOP

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; einen TEXT bertragen															
EXT_DISPLAY_BEISPIEL_A:
	; MASTER-START					
	ldi temp1,(ADRESSE_SLAVES_DISPLAY)	; ADRESSE laden		
	rcall TWI_MASTER_TRANSMITTER_START_TEMP1
	; ERROR							
	tst FEHLER_CODE
	brne EXT_DISPLAY_BEISPIEL_A_ERROR
	rcall EXT_DISPLAY_ZEILE1
	ldi ZH, high(TEXT_BEGRUESSUNG_1*2)	; TEXT 
	ldi ZL,  low(TEXT_BEGRUESSUNG_1*2)
	rcall EXT_DISPLAY_ANZEIGE_TEXT_Z
	rcall EXT_DISPLAY_ZEILE2
	ldi ZH, high(TEXT_BEGRUESSUNG_2*2)	; TEXT 
	ldi ZL,  low(TEXT_BEGRUESSUNG_2*2)
	rcall EXT_DISPLAY_ANZEIGE_TEXT_Z
	rcall EXT_DISPLAY_ZEILE3
	ldi ZH, high(TEXT_BEGRUESSUNG_3*2)	; TEXT 
	ldi ZL,  low(TEXT_BEGRUESSUNG_3*2)
	rcall EXT_DISPLAY_ANZEIGE_TEXT_Z
	rcall EXT_DISPLAY_ZEILE4
	ldi ZH, high(TEXT_BEGRUESSUNG_4*2)	; TEXT 
	ldi ZL,  low(TEXT_BEGRUESSUNG_4*2)
	rcall EXT_DISPLAY_ANZEIGE_TEXT_Z
	rcall TWI_STOP
	ret
EXT_DISPLAY_BEISPIEL_A_ERROR:
	rcall TWI_STOP
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; PORT PCF8574 auslesen															
EXT_DISPLAY_BEISPIEL_B:
	; ZEILE1	
	rcall LCD_CLEAR
	; MASTER-START					
	ldi temp1,(ADRESSE_SLAVES_DISPLAY)	; ADRESSE laden		
	rcall TWI_MASTER_RECEIVER_START_TEMP1
	; ERROR							
	tst FEHLER_CODE
	brne EXT_DISPLAY_BEISPIEL_B_ERROR
	rcall TWI_MASTER_RECEIVER_LAST_BYTE_TEMP1
	rcall LCD_AUSGABE_ZAHL_3_STELLEN_TEMP1		; inp: temp1
	rcall TWI_STOP
	ret
EXT_DISPLAY_BEISPIEL_B_ERROR:
	rcall TWI_STOP
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; RW-BIT immer "0"																
; E-BIT=0																		
EXT_DISPLAY_ENABLE_TEMP1:
	push temp1
	andi temp1,(1<<DISP_LED)|(0<<DISP_E)|(0<<DISP_RW)|(1<<DISP_RS)|(1<<DISP_D7)|(1<<DISP_D6)|(1<<DISP_D5)|(1<<DISP_D4)	; ENABLE
	rcall TWI_MASTER_TRANSMITTER_DATEN_TEMP1
	pop temp1
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; RS-BIT=0																		
EXT_DISPLAY_COMMAND_TEMP1:
	push temp1	; Sicherungskopie	
	; HIGH NIBBLE senden			
	SWAP temp1											; NIBBLES Tausch	
	andi temp1,0b00001111								; BITMUSTER			
	ori temp1,(1<<DISP_E)|(0<<DISP_RS)					; E=1 RS=0			
	rcall TWI_MASTER_TRANSMITTER_DATEN_TEMP1			; DATA				
	rcall EXT_DISPLAY_ENABLE_TEMP1						; Enable			
	; LOW NIBBLE senden			
	pop temp1											; wieder herstellen	
	andi temp1,0b00001111								; BITMUSTER			
	ori temp1,(1<<DISP_E)|(0<<DISP_RS)					; E=1 RS=0			
	rcall TWI_MASTER_TRANSMITTER_DATEN_TEMP1			; DATA				
	rcall EXT_DISPLAY_ENABLE_TEMP1						; Enable			
	; PAUSE						
	rcall wait_1ms
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; RS-BIT=1																		
EXT_DISPLAY_DATA_TEMP1:
	push temp1	; Sicherungskopie	
	; HIGH NIBBLE senden			
	SWAP temp1											; NIBBLES Tausch	
	andi temp1,0b00001111								; BITMUSTER			
	ori temp1,(1<<DISP_E)|(1<<DISP_RS)					; E=1 RS=1			
	rcall TWI_MASTER_TRANSMITTER_DATEN_TEMP1			; DATA				
	rcall EXT_DISPLAY_ENABLE_TEMP1						; Enable			
	; LOW NIBBLE senden			
	pop temp1											; wieder herstellen	
	andi temp1,0b00001111								; BITMUSTER			
	ori temp1,(1<<DISP_E)|(1<<DISP_RS)					; E=1 RS=1			
	rcall TWI_MASTER_TRANSMITTER_DATEN_TEMP1			; DATA				
	rcall EXT_DISPLAY_ENABLE_TEMP1						; Enable			
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Display lschen														  		
EXT_DISPLAY_CLEAR:
   	ldi temp1, 0b00000001
    rcall EXT_DISPLAY_COMMAND_TEMP1
	rjmp EXT_DISPLAY_ZEILE1
; ##############################################################################
; ##############################################################################
; ##############################################################################
; KURSOR GO-HOME														  		
EXT_DISPLAY_ZEILE1:
 	ldi temp1, 0b00000010
	rjmp EXT_DISPLAY_COMMAND_TEMP1
; ##############################################################################
; ##############################################################################
; ##############################################################################
; KURSOR Sprung in ZEILE2												  		
EXT_DISPLAY_ZEILE2:
 	ldi temp1, 0b11000000 
	rjmp EXT_DISPLAY_COMMAND_TEMP1
; ##############################################################################
; ##############################################################################
; ##############################################################################
; KURSOR Sprung in ZEILE3														
EXT_DISPLAY_ZEILE3:
	;ldi temp, 0b10010100  	; LCD 4x20	
	ldi temp1, 0b10010000 	; LCD 4x16	
	rjmp EXT_DISPLAY_COMMAND_TEMP1
; ##############################################################################
; ##############################################################################
; ##############################################################################
; KURSOR Sprung in ZEILE4												  		
EXT_DISPLAY_ZEILE4:
	;ldi temp, 0b11010100	; LCD 4x20	
	ldi temp1, 0b11010000 	; LCD 4x16	
	rjmp EXT_DISPLAY_COMMAND_TEMP1
; ##############################################################################
; ##############################################################################
; ##############################################################################
EXT_DISPLAY_ANZEIGE_TEXT_Z:
	LPM temp1, Z+   						; aus Tabelle laden und Z+1	
	tst temp1  			
	breq EXT_DISPLAY_ANZEIGE_TEXT_Z_FERTIG 	; Sprung	
	rcall EXT_DISPLAY_DATA_TEMP1			; Anzeige	
	rjmp EXT_DISPLAY_ANZEIGE_TEXT_Z
EXT_DISPLAY_ANZEIGE_TEXT_Z_FERTIG:

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################












