; ##############################################################################
; ##############################################################################
; ##############################################################################
WDR_INITIALISIERUNG:
; Watchdog aktivieren (max. Zeit)					
	ldi TEMP,(1<<WDCE)|(1<<WDE)  
	out wdtcr,TEMP       
	ldi TEMP,(1<<WDE) | (1<<WDP2)|(1<<WDP1)|(1<<WDP0) 
	out wdtcr,temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
NEUSTART_MIT_WDR:
	WDR
	in temp, MCUCSR
	andi temp,0b00001000
	tst temp
	breq NEUSTART_MIT_WDR_FEHLER
	; MCUCSR clear		
	out MCUCSR,NULL
	ret
NEUSTART_MIT_WDR_FEHLER:
	rjmp NEUSTART_MIT_WDR_FEHLER
; ##############################################################################
; ##############################################################################
; ##############################################################################
SRAM_CLEAR:
	ldi ZL, LOW (SRAM_START)
	ldi ZH, HIGH(SRAM_START)
	ldi temp,0
SRAM_CLEAR_w:
	ST z+,temp
	cpi ZH, HIGH(RAMEND-1)	; Vergleich?		
	brlo SRAM_CLEAR_w		; kleiner => SPRUNG	
	cpi ZL, LOW(RAMEND-1)	; Vergleich?		
	brlo SRAM_CLEAR_w		; kleiner => SPRUNG	
	breq SRAM_CLEAR_w		; gleich  => SPRUNG	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
PROGRAMM_CHECK:
	; NULL		
	tst NULL
	brne PROGRAMM_CHECK_FEHLER
	; EINS		
	mov temp,EINS
	cpi temp,1
	brne PROGRAMM_CHECK_FEHLER
	; VOLL		
	mov temp,VOLL
	cpi temp,255
	brne PROGRAMM_CHECK_FEHLER
	ret
; SCHLEIFE, bis WDR zubeit		
PROGRAMM_CHECK_FEHLER:
	rjmp PROGRAMM_CHECK_FEHLER
; ##############################################################################
; ##############################################################################
; ##############################################################################
LED_INITIALISIERUNG:
	; auf AUSGANG								
	sbi (LED_GRUEN_DDR),(LED_GRUEN_PIN_NR)		; GRN		
	sbi (LED_GELB_DDR),(LED_GELB_PIN_NR)		; GELB		
	sbi (LED_ROT_DDR),(LED_ROT_PIN_NR)			; ROT		
	sbi (BEEP_DDR),(BEEP_PIN_NR)				; BEEP		
	; LEDs an									
	cbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)		; GRN an	
	cbi (LED_GELB_PORT),(LED_GELB_PIN_NR)		; GELB an	
	cbi (LED_ROT_PORT),(LED_ROT_PIN_NR)			; ROT  an	
	sbi (BEEP_PORT),(BEEP_PIN_NR)				; BEEP  (H)	

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
LED_TEST:
	sbi (LED_GRUEN_PORT),LED_GRUEN_PIN_NR		; GRN aus	
	sbi (LED_GELB_PORT),LED_GELB_PIN_NR			; GELB aus	
	sbi (LED_ROT_PORT),LED_ROT_PIN_NR			; ROT  aus	

	cbi (LED_GRUEN_PORT),LED_GRUEN_PIN_NR		; GRN an   
	rcall wait_100ms
	cbi (LED_GELB_PORT),LED_GELB_PIN_NR			; GELB an	
	rcall wait_100ms
	cbi (LED_ROT_PORT),LED_ROT_PIN_NR			; ROT  an	
	rcall wait_100ms

	sbi (LED_GRUEN_PORT),LED_GRUEN_PIN_NR		; GRN aus	
	sbi (LED_GELB_PORT),LED_GELB_PIN_NR			; GELB aus	
	sbi (LED_ROT_PORT),LED_ROT_PIN_NR			; ROT  aus	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
TASTATUR_INITIALISIERUNG:	
	; auf EINGANG		
	cbi (TASTE_A_DDR),(TASTE_A_PIN_NR)
	cbi (TASTE_B_DDR),(TASTE_B_PIN_NR)
	cbi (TASTE_C_DDR),(TASTE_C_PIN_NR)
	cbi (TASTE_D_DDR),(TASTE_D_PIN_NR)

	; PULL-UP ein		
	sbi (TASTE_A_PORT),(TASTE_A_PIN_NR)
	sbi (TASTE_B_PORT),(TASTE_B_PIN_NR)
	sbi (TASTE_C_PORT),(TASTE_C_PIN_NR)
	sbi (TASTE_D_PORT),(TASTE_D_PIN_NR)

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
BEEP:
	clr temp
BEEP_w:
	cbi (BEEP_PORT),(BEEP_PIN_NR)				; BEEP  an	
	rcall wait_50us
	sbi (BEEP_PORT),(BEEP_PIN_NR)				; BEEP  aus	
	rcall wait_1ms
	dec temp
	brne BEEP_w
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
BEEP_TASTE:
	LDS temp,(adr_TASTE)
	tst temp
	brne BEEP_TASTE_RUN
	rcall wait_100ms
	ret
BEEP_TASTE_RUN:
	rcall BEEP
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
TASTEN_ABFRAGEN:
	STS(adr_TASTE),NULL		; NULL				
	clr temp
	sbis (TASTE_A_PIN),(TASTE_A_PIN_NR) ; Skip, wenn PIN HIGH
	ori temp,(TASTE_A)
	sbis (TASTE_B_PIN),(TASTE_B_PIN_NR) ; Skip, wenn PIN HIGH
	ori temp,(TASTE_B)
	sbis (TASTE_C_PIN),(TASTE_C_PIN_NR) ; Skip, wenn PIN HIGH
	ori temp,(TASTE_C)
	sbis (TASTE_D_PIN),(TASTE_D_PIN_NR) ; Skip, wenn PIN HIGH
	ori temp,(TASTE_D)

	cpi temp,(TASTE_C)+(TASTE_D)	
	breq TASTEN_ABFRAGEN_RESET

	sts(adr_TASTE),temp		; speichern	
ret
TASTEN_ABFRAGEN_RESET:
	cbi (LED_GRUEN_PORT),LED_GRUEN_PIN_NR		; GRN an   
	cbi (LED_GELB_PORT),LED_GELB_PIN_NR			; GELB an	
	cbi (LED_ROT_PORT),LED_ROT_PIN_NR			; ROT  an	
	rjmp TASTEN_ABFRAGEN_RESET
; ##############################################################################
; ##############################################################################
; ##############################################################################
