;												
; TWI/I2C LCD am PCF8574 fr ATmega8			
; Bernhard.Erfurt@gmx.de						
; 09/2011										
;												

;												
; Anschlussbelegung PINS						
;												
; PB0 ==> DISPLAY								
; PB1 ==> DISPLAY								
; PB2 ==> DISPLAY								
; PB3 ==> DISPLAY								
; PB4 ==> DISPLAY								
; PB5 ==> DISPLAY								
; PB6 ==> Quarz									
; PB7 ==> Quarz									
;												
; PC0 ==> LED-GRN								
; PC1 ==> LED-GELB								
; PC2 ==> LED-ROT								
; PC3 ==> BEEP									
; PC4 ==> TWI-SDA								
; PC5 ==> TWI-SCL								
;												
; PD0 ==> TASTE-A								
; PD1 ==> TASTE-B								
; PD2 ==> TASTE-C								
; PD3 ==> TASTE-D								
; PD4 ==> 										
; PD5 ==> 										
; PD6 ==> 										
; PD7 ==> 										
;												

; ATmega8 										
.include "m8def.inc"
; KONSTANTEN									
.equ TAKT					= 16000000			; 16 MHz	
; SLAVES										
.equ ADRESSE_SLAVES_DISPLAY	= 32
; TWI MASTER EINSTELLUNGEN						
.equ TWI_BIT_RATE			= 255				; 255	; Bit-Rate							
.equ TWI_PRESCALER			= 3					; 1		; Vorteiler: 0=1 1=4 2=16 3=64		
; FEHLER-CODES									
.equ ERROR_TWI_MT_START		= 10
.equ ERROR_TWI_MT_SLA		= 12
.equ ERROR_TWI_MT_DATA		= 14

.equ ERROR_TWI_MR_START		= 20
.equ ERROR_TWI_MR_SLA		= 21
.equ ERROR_TWI_MR_DATA		= 22
.equ ERROR_TWI_MR_DATAEND	= 23
; LED-GRUEN										
.equ LED_GRUEN_PIN_NR				= 0
.equ LED_GRUEN_DDR					= DDRC
.equ LED_GRUEN_PORT					= PORTC
; LED-GELB										
.equ LED_GELB_PIN_NR				= 1
.equ LED_GELB_DDR					= DDRC
.equ LED_GELB_PORT					= PORTC
; LED-ROT										
.equ LED_ROT_PIN_NR					= 2
.equ LED_ROT_DDR					= DDRC
.equ LED_ROT_PORT					= PORTC
; BEEP											
.equ BEEP_PIN_NR					= 3
.equ BEEP_DDR						= DDRC
.equ BEEP_PORT						= PORTC
; TASTE "A"										
.equ TASTE_A_PIN_NR					= 0
.equ TASTE_A_PIN					= PIND
.equ TASTE_A_DDR					= DDRD
.equ TASTE_A_PORT					= PORTD
; TASTE "B"										
.equ TASTE_B_PIN_NR					= 1
.equ TASTE_B_PIN					= PIND
.equ TASTE_B_DDR					= DDRD
.equ TASTE_B_PORT					= PORTD
; TASTE "C"										
.equ TASTE_C_PIN_NR					= 2
.equ TASTE_C_PIN					= PIND
.equ TASTE_C_DDR					= DDRD
.equ TASTE_C_PORT					= PORTD
; TASTE "D"										
.equ TASTE_D_PIN_NR					= 3
.equ TASTE_D_PIN					= PIND
.equ TASTE_D_DDR					= DDRD
.equ TASTE_D_PORT					= PORTD
; TASTEN-WERE									
.equ TASTE_A						= 1
.equ TASTE_B						= 2
.equ TASTE_C						= 4
.equ TASTE_D						= 8

; LCD (DATA)									
.equ LCD_DATA0_DDR					= DDRB
.equ LCD_DATA1_DDR					= DDRB
.equ LCD_DATA2_DDR					= DDRB
.equ LCD_DATA3_DDR					= DDRB
.equ LCD_DATA0_PORT					= PORTB
.equ LCD_DATA1_PORT					= PORTB
.equ LCD_DATA2_PORT					= PORTB
.equ LCD_DATA3_PORT					= PORTB
.equ LCD_DATA0						= 0
.equ LCD_DATA1						= 1
.equ LCD_DATA2						= 2
.equ LCD_DATA3						= 3
; LCD RS (Befehl/DATEN)							
.equ LCD_RS_DDR						= DDRB
.equ LCD_RS_PORT					= PORTB
.equ LCD_RS							= 4
; LCD_ENABLE									
.equ LCD_E_DDR						= DDRB
.equ LCD_E_PORT						= PORTB
.equ LCD_E							= 5
; externes DISPLAY								
.equ DISP_D4					= 0
.equ DISP_D5					= 1
.equ DISP_D6					= 2
.equ DISP_D7					= 3
.equ DISP_RS					= 4
.equ DISP_RW					= 5
.equ DISP_E						= 6
.equ DISP_LED					= 7
; SRAM-BELEGUNG ATmega8							
.equ adr_DATEN					= SRAM_START+0			; 0x0060 START Adresse 		
.equ adr_TASTE					= SRAM_START+11
.equ adr_MENUE					= SRAM_START+10 

.equ adr_TWI_SCAN_ADRESSE		= SRAM_START+100			; SCANNER	
.equ adr_TWI_SCAN_TREFFER		= SRAM_START+101			; SCANNER	
.equ adr_TWI_SCAN_BEREICH		= SRAM_START+102			; SCANNER	


.equ adr_TWI_BEREICH_READ		= SRAM_START+500





; REGISTER										

.def FEHLER_CODE=R9

.def NULL 	= R10
.def EINS 	= R11
.def VOLL	= R12

.def temp 	= R16
.def temp1 	= R17
.def temp2 	= R18
.def temp3 	= R19
.def temp4 	= R20
.def temp5 	= R21
.def temp6 	= R22
.def temp7 	= R23
.def temp8 	= R24
.def temp9 	= R25





.cseg					;Beginn eines Code-Segmentes
.org 0					;Startadresse=0

rjmp RESET      		; Reset Handler                           				
rjmp INTERRUPT_ERROR	;rjmp EXT_INT0   ; IRQ0 Handler                      	
rjmp INTERRUPT_ERROR	;rjmp EXT_INT1   ; IRQ1 Handler                      	
rjmp INTERRUPT_ERROR	;rjmp TIM2_COMP  ; Timer2 Compare Handler            	
rjmp INTERRUPT_ERROR	;rjmp TIM2_OVF   ; Timer2 Overflow Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_CAPT  ; Timer1 Capture Handler            	
rjmp INTERRUPT_ERROR	;rjmp TIM1_COMPA ; Timer1 CompareA Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_COMPB ; Timer1 CompareB Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_OVF   	  	; Timer1 Overflow Handler       
rjmp INTERRUPT_ERROR	;rjmp TIM0_OVF   ; Timer0 Overflow Handler           	
rjmp INTERRUPT_ERROR	;rjmp SPI_STC    ; SPI Transfer Complete Handler     	
rjmp INTERRUPT_ERROR	;rjmp ZEICHEN_EINLESEN 	; USART RX Complete Handler     
rjmp INTERRUPT_ERROR	;rjmp USART_UDRE ; UDR Empty Handler                 	
rjmp INTERRUPT_ERROR	;rjmp USART_TXC  ; USART TX Complete Handler         	
rjmp INTERRUPT_ERROR	;rjmp ADC        ; ADC Conversion Complete Handler   	
rjmp INTERRUPT_ERROR	;rjmp EE_RDY     ; EEPROM Ready Handler              	
rjmp INTERRUPT_ERROR	;rjmp ANA_COMP   ; Analog Comparator Handler         	
rjmp INTERRUPT_ERROR	;rjmp TWSI       ; Two-wire Serial Interface Handler 	
rjmp INTERRUPT_ERROR	;rjmp SPM_RDY    ; Store Program Memory Ready Handler	


; Bei unkorrekten Interrupt aufrufen erfolgt ein RESET ber WDR	
INTERRUPT_ERROR:
	wdr	
INTERRUPT_ERROR_SCHLEIFE:
	rjmp INTERRUPT_ERROR_SCHLEIFE

RESET:                        
; STACK initialisieren								
	ldi temp, LOW(RAMEND)
    out SPL, temp
    ldi temp, HIGH(RAMEND)
    out SPH, temp
; SRAM lschen										
	rcall SRAM_CLEAR
; STARTWERTE										
	; NULL				
	clr NULL
	; EINS				
	ldi temp,1
	mov EINS,temp
	; VOLL				
	ldi temp,255
	mov VOLL,temp
	; FEHLER CODE		
	clr FEHLER_CODE
; PORT B+C+D initialisieren								
	out DDRB, NULL
	out PORTB,NULL
	out DDRC, NULL
	out PORTC,NULL
	out DDRD, NULL
	out PORTD,NULL
; WDR_INITIALISIERUNG								
	rcall WDR_INITIALISIERUNG
; LED_INITIALISIERUNG								
	rcall LED_INITIALISIERUNG
; NEUSTART_MIT_WDR									
	rcall NEUSTART_MIT_WDR
; TASTATUR_INITIALISIERUNG							
	rcall TASTATUR_INITIALISIERUNG
; LCD_INITIALISIERUNG								
	rcall LCD_INITIALISIERUNG
; ANZEIGE_BEGRUESSUNG								
	rcall ANZEIGE_BEGRUESSUNG
; TWI_MASTER_INI									
	rcall TWI_INI
; interrupts freigeben								
	sei

; ##############################################################################
; ##############################################################################
; ##############################################################################
	rcall LED_TEST
	rcall wait_100ms
	rcall BEEP
	rcall ANZEIGE_HAUPT
; ##############################################################################
; ##############################################################################
; ##############################################################################
LOOP:
	WDR
	rcall PROGRAMM_CHECK	
	rcall TASTEN_ABFRAGEN
	rcall MENUE
	rcall ANZEIGE_ERROR_CODE
	rcall BEEP_TASTE
rjmp LOOP
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE:
	LDS temp,(adr_TASTE)
	cpi temp,(TASTE_A)
	breq MENUE_A
	cpi temp,(TASTE_B)
	breq MENUE_B
	cpi temp,(TASTE_C)
	breq MENUE_C
	cpi temp,(TASTE_D)
	breq MENUE_D
	ret
;-------------------------------------------------------------------------------
MENUE_A:
	rjmp TWI_SCAN
MENUE_B:
	rjmp EXT_DISPLAY_INITIALISIERUNG
MENUE_C:
	rjmp EXT_DISPLAY_BEISPIEL_A
MENUE_D:
	rjmp EXT_DISPLAY_BEISPIEL_B
	rjmp ANZEIGE_WARTUNG
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
.include "MASTER_LCD.asm"			; LCD-TEXTE				
.include "MASTER_LCD_ini.asm"		; LCD-INITIALISIERUNG	
.include "MASTER_LCD_EXT.asm"		; ext. LCD TWI			
.include "MASTER_SONSTIGES.asm"		; LED-TEST usw.			
.include "MASTER_TWI.asm"			; TWI-MASTER			
.include "MASTER_16MHZwait.asm"		; fr 16 MHZ Takt		
; ##############################################################################
; ##############################################################################
; ##############################################################################

;---------------------------------------
; Begrungstext						
TEXT_BEGRUESSUNG_1:
.db "I2C-TWI-LCD",0
TEXT_BEGRUESSUNG_2:
.db "ATmega8",0
TEXT_BEGRUESSUNG_3:
.db "Bernhard.Erfurt",0
TEXT_BEGRUESSUNG_4:
.db "09/2014  V1",0
;---------------------------------------
TEXT_ERROR:
.db "ERROR",0
;---------------------------------------
TEXT_TASTE_A:
.db "A>SCAN",0
TEXT_TASTE_B:
.db "B>INITIALISIERUNG",0
TEXT_TASTE_C:
.db "C>TEXT C+D>RESET",0
TEXT_TASTE_D:
.db "D>read",0
;---------------------------------------
TEXT_SCAN:
.db "SCAN",0







